var 	startTime;
var		running;
var		timer = null;
var		elapsedTime = {hours:0, minutes:0, seconds:0, milliseconds:0};
var		activeTime;
var		runTime;
var		accumulatedTime;

function setup()
{
	activeTime = 1;
	accumulatedTime = 0;
	running = false;
	document.getElementById("time1").innerText = "0:0:0.000";
	if (window.widget) {
		widget.onhide = onhide;
		widget.onshow = onshow;
	}

	return 0;
}

function toggleStopWatch() {

	if (timer) {
		clearInterval(timer);
		document.getElementById("starter").innerText = "Resume";
		document.getElementById("lapper").innerText = "Reset";
		timer = null;
		running = false;
		accumulatedTime += runTime;
	} else {
		startTime = (new Date).getTime();
		document.getElementById("starter").innerText = "Pause";
		if (activeTime < 5)
			document.getElementById("lapper").innerText = "Lap";
		timer = setInterval("updateTime();", 33);
		running = true;
	}
}

function updateTime() {
	if (running) {
		runTime = (new Date).getTime() - startTime;
		var x = runTime + accumulatedTime;

		elapsedTime.milliseconds = Math.floor(x % 1000);
		elapsedTime.seconds = Math.floor((x / 1000) % 60);
		elapsedTime.minutes = Math.floor((x / 60000) % 60);
		elapsedTime.hours = Math.floor(x / 3600000);

		document.getElementById("time" + activeTime).innerText = elapsedTime.hours + ":" + elapsedTime.minutes + ":" + elapsedTime.seconds + "." + elapsedTime.milliseconds;
	}
}

function lap() {

	if (document.getElementById("lapper").innerText == "Reset") {
		accumulatedTime = 0;
		for (activeTime = 5; activeTime > 1; activeTime--)
			document.getElementById("time" + activeTime).innerText = "";
		document.getElementById("time1").innerText = "0:0:0.000";
		document.getElementById("starter").innerText = "Start";
		document.getElementById("lapper").innerText = "";
		timer = null;
		running = false;
	
	} else if (activeTime < 5) {
		activeTime++;
		if (activeTime == 5)
			document.getElementById("lapper").innerText = "";
	}
}

function onshow() {
	if (!timer && running)
		timer = setInterval("updateTime();", 33);
}

function onhide() {
	clearInterval(timer);
	timer = null;
}

